#ifndef __ADVANCEDDIALOG_H__
#define __ADVANCEDDIALOG_H__

/////////////////////////////////////////////////////////////////////////////
// AdvancedDialog.h : header file for the CAdvancedDialog class
//
// Written by Loic Brayat (dev@pileouface.org)
//
// HOW TO:
//
// - Use the GUI to create the new dialog
// - In the .h file, replace the base class of the new dialog from 
//      CDialog to CAdvancedDialog
// - In the .h file, add the #include "AdvancedDialog.h" directory
// - In the .cpp file, in the constructor, replace CDialog by DAdvancedDialog
// - In the .cpp file, replace "CDialog::DoDataExchange" 
//      by "CAdvancedDialog::DoDataExchange"
// - Eventually do the same thing for OnInitDialog and the others functions
// - In the .cpp file, replace "BEGIN_MESSAGE_MAP(CTest, CDialog)" 
//      by "BEGIN_MESSAGE_MAP(CTest, CAdvancedDialog)"
// - Use the functions
//
// TIPS:
//
// - If you want the CAdvancedDialog childs to change automaticly, 
//    create the child dialog using a pointer on the main dialog as first param
//      Example : CMyDialogClass myDialogBow(this);
//
/////////////////////////////////////////////////////////////////////////////

#include <list>
#include "AdvancedComponent.h"

class CAdvancedDialog : public CDialog, public CAdvancedComponent
{
DECLARE_DYNAMIC(CAdvancedDialog)
// Construction

public:

	CAdvancedDialog(UINT nIDTemplate, CWnd* pParentWnd = NULL);
    CAdvancedDialog(LPCTSTR lpszTemplateName, CWnd* pParentWnd = NULL);

    ~CAdvancedDialog();

    bool bUpdateChild;

// Implementation
protected:

    void Initialize(CWnd * pParentWnd = NULL);

    void RedrawComponent();

    void CopyColorsFrom(const CAdvancedDialog* pDialog);
    
    CBrush cBrush;
    CAdvancedDialog * pParent;

    std::list<CAdvancedDialog*> lChilds;

	// Generated message map functions
	//{{AFX_MSG(CAdvancedDialog)
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
