﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using System.Diagnostics;
using System.Runtime.InteropServices; //für marshalling
using System.Windows.Media.Imaging;
using System.Threading;
using SRAPI_CSharp;
using System.Windows.Media;


namespace CSharp_UI
{

    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {

        static int SensorId, SensorId1, SensorId2;
        string projectDir = System.IO.Directory.GetParent(System.IO.Directory.GetCurrentDirectory()).Parent.FullName;

        SRAPI.StatusCB statuscb = new SRAPI.StatusCB(statusHandle);
        SRAPI.CBFunc CB_liveimg = new SRAPI.CBFunc(callBk_LiveImage);
        SRAPI.CBFuncDefaultMode CB_default = new SRAPI.CBFuncDefaultMode(callBk_default);
        static System.Windows.Controls.Image img = new System.Windows.Controls.Image();
        public const int livImgMaxHeight = 2880;// Configured for maximum 6 image acquisition in one Callback
        public const int livImgMaxWidth = 752;
        public static int livWidth = 0;
        public static int livHeight = 0;
        public static int livStartX = 0;
        public static int livValid = 0;
        public static short[] Imagedata = new short[livImgMaxHeight * livImgMaxWidth];
        public static short[] Imagedatacp = new short[livImgMaxHeight * livImgMaxWidth];

        public const int profMaxHeight = 5000; // Maximum configured profile Height : 5000 in one Callback
        public const int profMaxWidth = 1204;
        public static short[] profData = new short[profMaxWidth * profMaxHeight];
        public static short[] intensData = new short[profMaxWidth * profMaxHeight];
        public static short[] lltData = new short[profMaxWidth * profMaxHeight];
        public static short[] profDatacp = new short[profMaxWidth * profMaxHeight];
        public static short[] intensDatacp = new short[profMaxWidth * profMaxHeight];
        public static short[] lltDatacp = new short[profMaxWidth * profMaxHeight];
        public static int profWidth = 0;
        public static int profHeight = 0;
        public static int profStartX = 0;
        public static int profValid = 0;

 
        public static int callBk_LiveImage(int SensorId, int dattyp, int startX, int height, int width, ref short[] data)
        {

            //Console.WriteLine("In Call Back LiveImage");


            if (livValid == 0)
            {

/*
                // As a 2D Array
                for (int i = 0; i < height; i++)
                    for (int j = 0; j < width; j++)
                        Image[i, j] = data[(i * width) + j];
                */

                Imagedata = Enumerable.Repeat((short)0x0000, livImgMaxHeight * livImgMaxWidth).ToArray();
                // Converting to a global short imagedata
                Array.Copy(data, Imagedata, height * width);

                MainWindow.livWidth = width;
                MainWindow.livHeight = height;
                MainWindow.livStartX = startX;
                MainWindow.livValid = 1;
            }
            return 0;

        }
        public static int callBk_default(int sensorId, int dattyp, int startX, int height, int width, ref short[] profile,ref short[] intensity,ref short[] llt, int numExtData, ref int[] extData)
        {

            //Console.WriteLine("In Callback Profile");

            // Splitting the data into profile, intensity and laser line thickness according to the datatype
            if (profValid == 0)
            {
                profDatacp = Enumerable.Repeat((short)0x0000, profMaxWidth * profMaxHeight).ToArray();
                //int ret = SRAPI.getProfileComponents(dattyp, ref height, ref width, ref data, ref profData, ref intensData, ref lltData);
                Array.Copy(profile, profData, height * width);
                Array.Copy(intensity, intensData, height * width);
                Array.Copy(llt, lltData, height * width);
                MainWindow.profWidth = width;
                MainWindow.profHeight = height;
                MainWindow.profStartX = startX;
                MainWindow.profValid = 1;
            }
            return 0;
        } 

        public static bool in0, in1, in2, in3;
        public static int alivecnt = 0;
        public static bool alive = false;
        public static int statusHandle(int SensorId, int msgType, int msgdata1, int msgdata2, string msg)
        {
            string s = msg;

            if (msgType == SRAPI.Constants.MSGTYPE_DATA && msgdata1 == SRAPI.Constants.DATATYPE_IO)
            {
                if ((msgdata2 & 0x100) > 0)
                    in0 = true;
                else
                    in0 = false;
                if ((msgdata2 & 0x200) > 0)
                    in1 = true;
                else 
                    in1 = false;
                if ((msgdata2 & 0x400) > 0)
                    in2 = true;
                else
                    in2 = false;
                if ((msgdata2 & 0x800) > 0)
                    in3 = true;
                else
                    in3 = false;
            }

            if ((msgType == 4) && msgdata1 == 1)
            {
                alive = true;
                alivecnt++;
            }
            else   
                Console.WriteLine(s);

            return 0;

        }

        public static string ExePath, lastWord;
        public static string[] parts;
        public static bool exeApiFlag;

        public MainWindow()
        {
            InitializeComponent();

            button8.IsEnabled = true;
            button9.IsEnabled = false;
            button16.Visibility = System.Windows.Visibility.Hidden;
            button17.Visibility = System.Windows.Visibility.Hidden;
            button19.Visibility = System.Windows.Visibility.Hidden;

            
            liveDispImg.Visibility = System.Windows.Visibility.Hidden;
            profDispImg.Visibility = System.Windows.Visibility.Hidden;
            intenDispImg.Visibility = System.Windows.Visibility.Hidden;
            lltDispImg.Visibility = System.Windows.Visibility.Hidden;

            image1.Visibility = System.Windows.Visibility.Visible;

            rectangle1.Fill = Brushes.Gainsboro;
            rectangle2.Fill = Brushes.Gainsboro;
            rectangle11.Fill = Brushes.Gainsboro;

            rectangle7.Fill = Brushes.Gainsboro;
            rectangle8.Fill = Brushes.Gainsboro;
            rectangle9.Fill = Brushes.Gainsboro;
            rectangle10.Fill = Brushes.Gainsboro;


            textBox1.Text = ((int)1280).ToString();
            textBox2.Text = ((int)1024).ToString();
            textBox3.Text = ((int)0).ToString();
            textBox4.Text = ((int)0).ToString();

            ExePath = System.AppDomain.CurrentDomain.BaseDirectory;
            parts = ExePath.Split('\\');
            lastWord = parts[parts.Length - 2];

            if (lastWord == "bin" || lastWord == "binx64")
                exeApiFlag = true;
            else
                exeApiFlag = false;

            hide_images();

            canvas1.Background = tabControl1.Background;

            ImageBrush myBrush = new ImageBrush();
#if WIN64
            if (exeApiFlag == false)
            {
            myBrush.ImageSource = new BitmapImage(new Uri(projectDir + "\\..\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Images\\gui_API_Demo.png", UriKind.Absolute));
            this.Background = myBrush;

            image1.Source = new BitmapImage(new Uri(projectDir + "\\..\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Images\\GUI_Custcare.png", UriKind.Absolute)); 
            }

            else
            {
                string Respath1 = ExePath + "..\\resources\\sr_api_csharp_demo\\Images\\gui_API_Demo.png";
                string Respath2 = ExePath + "..\\resources\\sr_api_csharp_demo\\Images\\GUI_Custcare.png";
                myBrush.ImageSource = new BitmapImage(new Uri(Respath1, UriKind.Absolute));
                this.Background = myBrush;

                image1.Source = new BitmapImage(new Uri(Respath2, UriKind.Absolute));
            }
#else

            if (exeApiFlag == false)
            {
                myBrush.ImageSource = new BitmapImage(new Uri(projectDir + "\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Images\\gui_API_Demo.png", UriKind.Absolute));
                this.Background = myBrush;

                image1.Source = new BitmapImage(new Uri(projectDir + "\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Images\\GUI_Custcare.png", UriKind.Absolute));
            }

            else
            {
                string Respath1 = ExePath + "..\\resources\\sr_api_csharp_demo\\Images\\gui_API_Demo.png";
                string Respath2 = ExePath + "..\\resources\\sr_api_csharp_demo\\Images\\GUI_Custcare.png";
                myBrush.ImageSource = new BitmapImage(new Uri(Respath1, UriKind.Absolute));
                this.Background = myBrush;

                image1.Source = new BitmapImage(new Uri(Respath2, UriKind.Absolute));
            }

#endif


            Debug.WriteLine("Waiting to Initialize the API");

            Thread liveThread = new Thread(display_imageThread);
            // Start the Live Image thread.
            liveThread.Start();
            Console.WriteLine("main thread: Starting liveThread...");
            // Loop until Live Image thread activates.
            while (!liveThread.IsAlive) ;

            Thread profThread = new Thread(display_profileThread);
            // Start the Profile thread.
            profThread.Start();
            Console.WriteLine("main thread: Starting ProfileThread...");
            // Loop until Profile thread activates.
            while (!profThread.IsAlive) ;
/*
            Thread sensorStatusThread = new Thread(display_sensorStatusThread);
            // Start the Status thread.
            sensorStatusThread.Start();
            Console.WriteLine("main thread: Starting Sensor Status Thread...");
            // Loop until Live Image thread activates.
            while (!sensorStatusThread.IsAlive) ;
            */

            System.Windows.Threading.DispatcherTimer dispatcherTimer = new System.Windows.Threading.DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            dispatcherTimer.Interval = new TimeSpan(0,0,0,0,250);
            dispatcherTimer.Start();

        }
        public static bool aliveevent = false;
        public static int alivecnt1 = 0, alivetout = 0;
        private void dispatcherTimer_Tick(object sender, EventArgs e)
        {

            Action action;
            if ((SRAPI.getConnectionState(SensorId) == SRAPI.Constants.STATE_CAMERA_CONNECTED) && alive)
            {
                    aliveevent = !aliveevent;
                    if (alivecnt1 == alivecnt)
                        alivetout++;
                    else
                        alivetout = 0;
                    alivecnt1 = alivecnt;
                    if (alivetout > 9)
                    {
                        aliveevent = false;
                    }
                    //alive = false;
            }

            else
                aliveevent = false;

            if (aliveevent)
            {
                action = delegate { rectangle11.Fill = Brushes.LimeGreen; };
                rectangle11.Dispatcher.Invoke(action);
            }
            else
            {
                action = delegate { rectangle11.Fill = Brushes.Gainsboro; };
                rectangle11.Dispatcher.Invoke(action);
            }

            if (SRAPI.getConnectionState(SensorId) == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                action = delegate { rectangle2.Fill = Brushes.LimeGreen; };
                rectangle2.Dispatcher.Invoke(action);

                if (in0)
                {
                    action = delegate { rectangle7.Fill = Brushes.LimeGreen; };
                    rectangle7.Dispatcher.Invoke(action);
                }
                else
                {
                    action = delegate { rectangle7.Fill = Brushes.Gainsboro; };
                    rectangle7.Dispatcher.Invoke(action);
                }

                if (in1)
                {
                    action = delegate { rectangle8.Fill = Brushes.LimeGreen; };
                    rectangle8.Dispatcher.Invoke(action);
                }
                else
                {
                    action = delegate { rectangle8.Fill = Brushes.Gainsboro; };
                    rectangle8.Dispatcher.Invoke(action);
                }

                if (in2)
                {
                    action = delegate { rectangle9.Fill = Brushes.LimeGreen; };
                    rectangle9.Dispatcher.Invoke(action);
                }
                else
                {
                    action = delegate { rectangle9.Fill = Brushes.Gainsboro; };
                    rectangle9.Dispatcher.Invoke(action);
                }
                if (in3)
                {
                    action = delegate { rectangle10.Fill = Brushes.LimeGreen; };
                    rectangle10.Dispatcher.Invoke(action);
                }
                else
                {
                    action = delegate { rectangle10.Fill = Brushes.Gainsboro; };
                    rectangle10.Dispatcher.Invoke(action);
                }
            }
            else
            {
                action = delegate { rectangle2.Fill = Brushes.Red; };
                rectangle2.Dispatcher.Invoke(action);

            }
        }
        private void initialize_API_Click(object sender, RoutedEventArgs e)
        {

            string Api_Version = "";

            //--------------------------------------
            // Get API Version 
            //--------------------------------------
            int ret = SRAPI.getAPIVersion(ref Api_Version);
            if (ret != 0)
                Debug.WriteLine("\rAPI Version Error. Errorcode: " + ret);
            else
            {
                Debug.WriteLine("\rSmartRay API Ver :");
                Debug.WriteLine(Api_Version);
            }

            //--------------------------------------
            // Initialize API and Message Callback 
            //--------------------------------------
            ret = SRAPI.init(statuscb);
            if (ret != 0)
                Debug.WriteLine("\rSR_API_Init Error" + ret);
            else
            {
                Debug.WriteLine("\rSR_API_Init Success");
                rectangle1.Fill = Brushes.LimeGreen;
                rectangle2.Fill = Brushes.Gainsboro;
            }


            ret = -100;
            //--------------------------------------
            // Register User CallBack function for Live Image Mode
            //--------------------------------------
            ret = SRAPI.registerUserCB(SRAPI.Constants.SRCB_CAMDATAMODE, 0x8010, CB_liveimg);
            if (ret != 0)
                Debug.WriteLine("\rRegister LiveImage Callback Error" + ret);
            else
                Debug.WriteLine("\rRegistered: LiveImage Callback");


            //--------------------------------------
            // Register User CallBack function for Default Mode
            //--------------------------------------
            ret = SRAPI.registerUserCB(SRAPI.Constants.SRCB_SENSORDEFAULTMODE, 0x8020, CB_default);
            if (ret != 0)
                Debug.WriteLine("\rRegister  Default Data Callback Error" + ret);
            else
                Debug.WriteLine("\rRegistered: Default Data Callback");



            Debug.WriteLine("\rSmartRay API Initialized");


           // button8.IsEnabled = false;
            button9.IsEnabled = true;


        }
        private void window_Loaded(object sender, RoutedEventArgs e)
        {
          
        }
        private void captureProfile_Click(object sender, RoutedEventArgs e)
        {

            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            //int config_var;
            if (conState != SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                Debug.WriteLine("\rThe Sensor is not connected");
            }
            else
            {
                //--------------------------------------
                // Stop the Sensor
                //--------------------------------------
                int ret = SRAPI.stopSensor(SensorId);
                if (ret != 0)
                    Debug.WriteLine("\rStop Sensor Failed" + ret);
                else
                {
                    Debug.WriteLine("\rSensor Stopped");
                    Debug.WriteLine("\rSee the console window for results");
                }


                button19.Visibility = System.Windows.Visibility.Hidden;
                button2.Visibility = System.Windows.Visibility.Visible;

                config_Param_Func(1); //Configure for profile Capture


                if (param_loaded == true)
                {
                    button18.IsEnabled = true;
                    button1.IsEnabled = true;

                    if (roiSet)
                        ret = SRAPI.setImager(SensorId, inpStartX, inpStartY, inpWidth, inpHeight, gainEnable, gain);
                    else
                    {
                        ret = SRAPI.getSensorSize(SensorId, ref inpWidth, ref inpHeight);
                        ret = SRAPI.setImager(SensorId, 0, 0, inpWidth, inpHeight, 0, 0);

                    }

                    if (!expSet)
                    {
                        //--------------------------------------
                        // Get Exposure time
                        //--------------------------------------
                        ret = SRAPI.getExposure(SensorId, ref enDoubleExpo, ref expSmall, ref expLarge);
                        if (ret == 0)
                        {
                            if (enDoubleExpo == 1)
                                checkBox2.IsChecked = true;
                            else
                                checkBox2.IsChecked = false;

                            textBox5.Text = expSmall.ToString();
                            textBox7.Text = expLarge.ToString();

                            if (checkBox2.IsChecked == false)
                                textBox7.IsEnabled = false;
                            else
                                textBox7.IsEnabled = true;
                        }
                    }
                    else
                    {
                        //--------------------------------------
                        // Set Exposure time
                        //--------------------------------------
                        ret = SRAPI.setExposure(SensorId, enDoubleExpo, expSmall, expLarge);
                    }
                }
                //--------------------------------------
                // Clear Profile Buffer
                //--------------------------------------
                profDispImg.Source = null;
                intenDispImg.Source = null;
                lltDispImg.Source = null;

                //--------------------------------------
                // Start the Sensor
                //--------------------------------------
                ret = SRAPI.startSensor(SensorId);
                if (ret != 0)
                    Debug.WriteLine("\rSensor Start Failed" + ret);
                else
                {
                    Debug.WriteLine("\rSensor Started");
                    Debug.WriteLine("\rSee the console window for results");
                    Debug.WriteLine("\rUse Display buttons to view respective results");
                    Debug.WriteLine("\rClick Configure button for a different mode");
                }

                button11.Visibility = System.Windows.Visibility.Hidden;
                button17.Visibility = System.Windows.Visibility.Visible;


                liveDispImg.Visibility = System.Windows.Visibility.Hidden;
                profDispImg.Visibility = System.Windows.Visibility.Visible;
                intenDispImg.Visibility = System.Windows.Visibility.Hidden;
                lltDispImg.Visibility = System.Windows.Visibility.Hidden;
                border1.Visibility = System.Windows.Visibility.Visible;

                button13.IsEnabled = true;
                button10.IsEnabled = false;
                button14.IsEnabled = true;
                button15.IsEnabled = true;


            }
        }
        private void connect_Sensor_Click(object sender, RoutedEventArgs e)
        {
            button16.Visibility = System.Windows.Visibility.Visible;
            button9.Visibility = System.Windows.Visibility.Visible;

            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
    //        if (conState != SRAPI.Constants.STATE_CAMERA_CONNECTED)
    //        {
                string SensorName = "Sensor0";
                    // A Sensor Instance is identified uniquely with the SensorName and IP Address
                    // Returns SensorId if successful, -ve value if not successful

                    SensorId1 = SRAPI.connectSensor(SensorName, SRAPI.Constants.DEFAULT_IP_ADR, SRAPI.Constants.DEFAULT_PORT_NUM);
                    SensorId = SensorId1;
                if (SensorId >= 0)
                    {
                        Debug.WriteLine("\rSensor Connection Requested: Instance: " + SensorId);
                        Debug.WriteLine("\rSee the console window for connection status ");
                        Debug.WriteLine("\rIf the Sensor is Alive, Click Configure to configure the Sensor");
                    }
                    else
                        Debug.WriteLine("\rSensor Not Connected: Instance: " + SensorId);


                 //   button9.Visibility = System.Windows.Visibility.Hidden;
                 //   button16.Visibility = System.Windows.Visibility.Visible;

          //  }
            
        }
        private void stop_Sensor_Click(object sender, RoutedEventArgs e)
        {
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState != SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                Debug.WriteLine("\rThe Sensor is not connected");
            }
            else
            {
                    //stop the camera
                    int ret = SRAPI.stopSensor(SensorId);
                    if (ret != 0)
                        Debug.WriteLine("\rSensor Stop Failed" + ret);
                    else
                    {
                        Debug.WriteLine("\rSensor Stopped");
                        Debug.WriteLine("\rClick Start to start the sensor, Click configure to configure for a different mode");
                    }


                    button17.Visibility = System.Windows.Visibility.Hidden;
                    button11.Visibility = System.Windows.Visibility.Visible;

                    button19.Visibility = System.Windows.Visibility.Hidden;
                    button2.Visibility = System.Windows.Visibility.Visible;
              }
        }
        private void close_Application_Click(object sender, RoutedEventArgs e)
        {
           // liveThread.Stop();
            string sensname = "";
            int ret = 100;
            ret = SRAPI.getName(SensorId, ref sensname);
            ret = 100;
            ret = SRAPI.disconnectSensor(sensname);

          //  button16.Visibility = System.Windows.Visibility.Hidden;
          //  button9.Visibility = System.Windows.Visibility.Visible;
            

            Environment.Exit(0);
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            // liveThread.Stop();
            string sensname = "";
            int ret = 100;
            ret = SRAPI.getName(SensorId, ref sensname);
            ret = 100;
            ret = SRAPI.disconnectSensor(sensname);
            
            //  button16.Visibility = System.Windows.Visibility.Hidden;
            //  button9.Visibility = System.Windows.Visibility.Visible;


            Environment.Exit(0);

        }



        private void verify_API_Func()
        {
            int retcheck = 0;
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                //--------------------------------------
                // Read MAC ID
                //--------------------------------------
                string macstr = "";
                int ret = SRAPI.getMACAdr(SensorId, ref macstr);
                Console.WriteLine(macstr, " MAC ID");
                if (ret != 0) retcheck = 1;

                //--------------------------------------
                // Read Serial Number
                //--------------------------------------
                string serial = "";
                ret = SRAPI.getSerial(SensorId, ref serial);
                Console.WriteLine(serial, " Serial No.");
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Software Version
                //--------------------------------------
                string str = "";
                ret = SRAPI.getSwVersion(SensorId, ref str);
                Console.WriteLine(str, "Sw version");
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Hardware Version
                //--------------------------------------
                ret = SRAPI.getHwVersion(SensorId, ref str);
                Console.WriteLine(str, "Hw version");
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Sensor Type
                //--------------------------------------
                ret = SRAPI.getSensorType(SensorId, ref str);
                Console.WriteLine(str, "Part Number");
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Sensor Size
                //--------------------------------------
                int wid = 0;
                int hei = 0;
                ret = SRAPI.getSensorSize(SensorId, ref wid, ref hei);
                Console.WriteLine("Width =" + wid + " Height =" + hei);
                if (ret != 0) retcheck = 1;

                //--------------------------------------
                // Read Sensor Center Position
                //--------------------------------------
                int cenx = 0;
                int ceny = 0;
                ret = SRAPI.getSensorCenterPosition(SensorId, ref cenx, ref ceny);
                Console.WriteLine("Centre X =" + cenx + " Centre Y =" + ceny);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Set The Laser Properties
                //--------------------------------------
                ret = SRAPI.setLaser(SensorId, 1, 0, 1, 100);
                Console.WriteLine("Laser Set Return" + ret);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Set The Outputs
                //--------------------------------------
                ret = SRAPI.setOutput(SensorId, 1, 1);
                Console.WriteLine("Set Output 1 value:" + 1);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Sensor Inputs
                //--------------------------------------
                ret = SRAPI.getInput(SensorId, 1, ref cenx);
                Console.WriteLine("Input 1 value:" + cenx);
                if (ret != 0) retcheck = 1;

                //--------------------------------------
                // Set Exposure of Sensor
                //-------------------------------------
                //ret = SRAPI.SetExposure(SensorId, 0, 50000, 50000);

                //--------------------------------------
                // Read Imager Properties
                //--------------------------------------
                int startx = 0;
                int starty = 0;
                int width = 0;
                int height = 0; int gainEnable = 0;
                int gain = 0;
                ret = SRAPI.getImager(SensorId, ref startx, ref  starty, ref  width, ref  height, ref  gainEnable, ref  gain);
                Console.WriteLine("GetImager -  " + startx + ":" + starty + ":" + width + ":" + height + ":" + gainEnable + ":" + gain);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Exposure Setting
                //--------------------------------------
                ret = SRAPI.getExposure(SensorId, ref startx, ref starty, ref width);
                Console.WriteLine("GetExposure -  " + startx + ":" + starty + ":" + width);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Trigger Properties
                //--------------------------------------
                int mode = 0; int source = 0; int edge = 0; int outputselect = 0; int trigfrq = 0; int trigcnt = 0; int trigoffset = 0;
                ret = SRAPI.getTrigger(SensorId, ref  mode, ref  source, ref  edge, ref  outputselect, ref  trigfrq, ref  trigcnt, ref  trigoffset);
                Console.WriteLine("GetTrigger -  " + mode + ":" + source + ":" + edge + ":" + outputselect + ":" + trigfrq + ":" + trigcnt + ":" + trigoffset);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read ErrorString from Errorcode
                //--------------------------------------
                ret = SRAPI.getErrorString(-1002, ref str);
                Console.WriteLine(str);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Factory Name of Sensor
                //--------------7------------------------
                ret = SRAPI.getSensorName(SensorId, ref str);
                Console.WriteLine("Factory Name - {0}", str);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Sensor Name
                //--------------------------------------
                ret = SRAPI.getName(SensorId, ref str);
                Console.WriteLine("Sensor Name - {0} ", str);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Sensor IP Address
                //--------------------------------------
                ret = SRAPI.getIp(SensorId, ref str);
                Console.WriteLine("IP - {0}", str);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Read Sensor TCPIP Portnumber
                //--------------------------------------
                ret = SRAPI.getPortNum(SensorId);
                Console.WriteLine("Port Num " + ret);

                //--------------------------------------
                // Read Sensor Connection State
                //--------------------------------------
                ret = SRAPI.getConnectionState(SensorId);
                Console.WriteLine("GetConnectionState " + ret);

                //--------------------------------------
                // Read Laser Status I
                //--------------------------------------
                ret = SRAPI.getLaserLightStatus(SensorId);
                Console.WriteLine("GetLaserLightStatus " + ret);

                //--------------------------------------
                // Read Laser Status II
                //--------------------------------------
                ret = SRAPI.getLaserEnableStatus(SensorId);
                Console.WriteLine("GetLaserEnableStatus " + ret);

                //--------------------------------------
                // Read Sensor Framerate
                //--------------------------------------
                ret = SRAPI.getFps(SensorId);
                Console.WriteLine("Fps " + ret);

                //--------------------------------------
                // Read Sensor Triggerrate
                //--------------------------------------
                ret = SRAPI.getTps(SensorId);
                Console.WriteLine("Tps " + ret);

                //--------------------------------------
                // Read Sensor Temperature
                //--------------------------------------
                float ret1 = SRAPI.getTemp(SensorId);
                Console.WriteLine("Temp " + ret1);

                //--------------------------------------
                // Load Sensor LuT
                //--------------------------------------
                string LutPath = "";
#if WIN64
                if (exeApiFlag == false)
                {
                    LutPath = (projectDir + "\\..\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Calibration\\SRN_00-00-810.lut"); 
                }
                else
                {
                    LutPath = (ExePath + "..\\resources\\sr_api_csharp_demo\\Calibration\\SRN_00-00-810.lut"); 
                    
                }  
#else
                if (exeApiFlag == false)
                {
                    LutPath = (projectDir + "\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Calibration\\SRN_00-00-810.lut"); 
                }
                else
                {
                    LutPath = (ExePath + "..\\resources\\sr_api_csharp_demo\\Calibration\\SRN_00-00-810.lut"); 
                    
                }  
                
#endif

                ret = SRAPI.loadLutFromFile(SensorId, LutPath);
                if (ret == 0)
                    Debug.WriteLine("\rLut Read Success");
                else
                    Debug.WriteLine("\rLut Read Failed" + ret);
                if (ret != 0) retcheck = 1;

                //--------------------------------------
                // Create World data from Lut and Profile
                //--------------------------------------
                int StartX = 0;
                int Width = 752;
                IntPtr prof = Marshal.AllocHGlobal(Width * sizeof(short));
                short[] array = Enumerable.Repeat((short)240, Width).ToArray();
                Marshal.Copy(array, 0, prof, Width);
                SRAPI.SR_3DPOINT[] world = new SRAPI.SR_3DPOINT[Width];

                ret = SRAPI.createWorldData(SensorId, StartX, Width, prof, ref world);
                if (ret == 0)
                    Debug.WriteLine("\rCreate 3D Success ");
                else
                    Debug.WriteLine("\rCreate 3D Failed " + ret);
                if (ret != 0) retcheck = 1;
                //--------------------------------------
                // Create Remapper data from World Coordinates
                //--------------------------------------
                short[] intens = Enumerable.Repeat((short)0x0010, Width).ToArray();
                short[] iS = new short[Width];
                short[] zS = new short[Width];
                float range_start = (float)-28.2481728;
                float range_end = (float)28.12141;
                float offsetZ = (float)30.0;
                float scaleZ = (float)0.01;
                ret = SRAPI.remapWorldToMatrix(ref world, ref intens, Width, range_start, range_end, ref iS, ref zS, offsetZ, scaleZ);

                if (ret == 0)
                    Debug.WriteLine("\rRemap 3D Success ");
                else
                    Debug.WriteLine("\rRemap 3D Failed " + ret);
                if (ret != 0) retcheck = 1;


                if (retcheck == 1)
                    Debug.WriteLine("\rAPI Function Test Error");
                else
                    Debug.WriteLine("\rAPI Function Test Success");

                Debug.WriteLine("\rSee the console window for more results");
            }
        }
        public static int config_var = 0;
        public void config_Param_Func(int par)
        {
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                Debug.WriteLine("\rThe Sensor is connected");
                //--------------------------------------
                // Read Sensor Parameters from file
                //-------------------------------------- 
                int ret = -100;

                if (par == 0)
                {
#if WIN64
                    if (exeApiFlag == false)
                    {
                    string path = projectDir + "\\..\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_LiveImage.par";
                    ret = SRAPI.readCamParsFromFile(path);
                    }
                    else
                    {
                        
                        ret = SRAPI.readCamParsFromFile(ExePath + "..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_LiveImage.par");
                    }
#else

                    if (exeApiFlag == false)
                    {
                        ret = SRAPI.readCamParsFromFile(projectDir + "\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_LiveImage.par");
                    }

                    else
                    {
                        
                        ret = SRAPI.readCamParsFromFile(ExePath + "..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_LiveImage.par");
                    }
                   
#endif

                }
                else if (par == 1)
                {
#if WIN64
                    if (exeApiFlag == false)
                    {
                        ret = SRAPI.readCamParsFromFile(projectDir + "\\..\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_3DFixedMode.par");
                    }
                    else
                    {
                        
                        ret = SRAPI.readCamParsFromFile(ExePath + "..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_3DFixedMode.par");
                    }  

#else
                    if (exeApiFlag == false)
                    {
                        ret = SRAPI.readCamParsFromFile(projectDir + "\\..\\..\\..\\..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_3DFixedMode.par");
                    }
                    else
                    {

                        ret = SRAPI.readCamParsFromFile(ExePath + "..\\resources\\sr_api_csharp_demo\\Parameter\\SR700_3DFixedMode.par");
                    }                    
#endif
                }

                if (ret != 0)
                    Debug.WriteLine("\rReadCamParsFromFile Failed " + ret);
                else
                    Debug.WriteLine("\rReadCamParsFromFile Success");


                if (roiSet) // Change memory parameterset according to the user input 
                {
                    ret = SRAPI.setImager(SensorId, inpStartX, inpStartY, inpWidth, inpHeight, gainEnable, gain);
                }
				else
                {
                    ret = SRAPI.getSensorSize(SensorId, ref inpWidth, ref inpHeight);
                    ret = SRAPI.setImager(SensorId, 0, 0, inpWidth, inpHeight, 0, 0);
                    
                }

                //--------------------------------------
                // Send Parameter to Scanner
                //--------------------------------------
                ret = SRAPI.sendParsToCam(SensorId);
                if (ret != 0)
                    Debug.WriteLine("\rSendParsToCam Failed " + ret);
                else
                {
                    Debug.WriteLine("\rSendParsToCam Success");
                    if (par == 0)
                    {
                       Debug.WriteLine("\rConfigured for the Live Image Callback");
                       param_loaded = true;
                    }
                    else
                    {
                        Debug.WriteLine("\rConfigured for the Profile Callback");
                        param_loaded = true;
                    }
                    Debug.WriteLine("\rClick Start to start the sensor");
                }


            }

            else
                Debug.WriteLine("\rThe Sensor is not connected");

        }
        public static int x, y;
        public void display_imageThread()
        {
            double dpi = 96;
            BitmapSource bmpSrc;
            Action action;
            
            while (true)
            {
                if (livValid == 1)
                {
                    lock (Imagedata)
                    {
                        for (int i = 0; i < livHeight / divY; i++)
                            for (int j = 0; j < livWidth / divX; j++)
                            {
                                Imagedatacp[(i * (livWidth / divX)) + j] = Imagedata[(i * livWidth * divY) + j * divX];
                            }
                        action = delegate
                        {
                            border1.Height = livHeight / divY;
                            border1.Width = livWidth / divX;
                            if (border1.Height > MaxDispY)
                                border1.Height = MaxDispY;
                            if (border1.Width > MaxDispX)
                                border1.Width = MaxDispX;
                        };
                        border1.Dispatcher.Invoke(action);


                        bmpSrc = BitmapSource.Create((livWidth / divX), (livHeight / divY), dpi, dpi, System.Windows.Media.PixelFormats.Gray8, null, Imagedatacp, (livWidth / divX));
                       // bmpSrc = BitmapSource.Create(livWidth, livHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, Imagedata, livWidth/divX);
                        bmpSrc.Freeze();
                        //getPos(livWidth, livHeight, ref x, ref y);
                        action = delegate {liveDispImg.Source = bmpSrc;};
                        liveDispImg.Dispatcher.Invoke(action);
                        
                        Action actionp = delegate { profDispImg.Source = null; };
                        Action actioni = delegate { intenDispImg.Source = null; };
                        Action actionl = delegate { lltDispImg.Source = null; };
                        profDispImg.Dispatcher.Invoke(actionp);
                        intenDispImg.Dispatcher.Invoke(actioni);
                        lltDispImg.Dispatcher.Invoke(actionl);

                       
                    }
                    livValid = 0;
                }

            }
        }
        public static bool testop;
        public void display_sensorStatusThread()
        {

            Action action;
            while (true)
            {
                if (SRAPI.getConnectionState(SensorId) == SRAPI.Constants.STATE_CAMERA_CONNECTED)
                {
                    action = delegate { rectangle2.Fill = Brushes.LimeGreen; };
                    rectangle2.Dispatcher.Invoke(action);

                    if (in0)
                    {
                        action = delegate { rectangle7.Fill = Brushes.LimeGreen; };
                        rectangle7.Dispatcher.Invoke(action);
                    }
                    else
                    {
                        action = delegate { rectangle7.Fill = Brushes.Gainsboro; };
                        rectangle7.Dispatcher.Invoke(action);
                    }

                    if (in1)
                    {
                        action = delegate { rectangle8.Fill = Brushes.LimeGreen; };
                        rectangle8.Dispatcher.Invoke(action);
                    }
                    else
                    {
                        action = delegate { rectangle8.Fill = Brushes.Gainsboro; };
                        rectangle8.Dispatcher.Invoke(action);
                    }

                    if (in2)
                    {
                        action = delegate { rectangle9.Fill = Brushes.LimeGreen; };
                        rectangle9.Dispatcher.Invoke(action);
                    }
                    else
                    {
                        action = delegate { rectangle9.Fill = Brushes.Gainsboro; };
                        rectangle9.Dispatcher.Invoke(action);
                    }
                    if (in3)
                    {
                        action = delegate { rectangle10.Fill = Brushes.LimeGreen; };
                        rectangle10.Dispatcher.Invoke(action);
                    }
                    else
                    {
                        action = delegate { rectangle10.Fill = Brushes.Gainsboro; };
                        rectangle10.Dispatcher.Invoke(action);
                    }
                }
                else
                {
                    action = delegate { rectangle2.Fill = Brushes.Red; };
                    rectangle2.Dispatcher.Invoke(action);

                }
        
            }
        }
        int l = 0;
        public void display_profileThread()
        {
            double dpi = 96;
            BitmapSource profSrc, intenSrc, lltSrc;
            while (true)
            {
                if (profValid == 1)
                {
                lock (profData)
                    lock (intensData)
                        lock (lltData)
                        {
                              /*  // Extract the intensity data
                                for (int i = 0; i < profHeight * profWidth; i++)
                                {
                                    intensData[i] = (short)(intensData[i] >> 4);
                                    //intensData[i] = (short)(intensData[i] << 4);
                                }*/
                                int maxp = 0;
                                int maxi = 0;
                                int maxl = 0;
                                int divp = 1;
                                int divi = 1;
                                int divl = 1;
                                for (int i = 0; i < profHeight; i++)
                                    for (int j = 0; j < profWidth / divX; j++)
                                    {
                                        
                                        profDatacp[(i * (profWidth / divX)) + j] = (short) (profData[(i * profWidth) + j * divX]);
                                        intensDatacp[(i * (profWidth / divX)) + j] = intensData[(i * profWidth) + j * divX];
                                        lltDatacp[(i * (profWidth / divX)) + j] = lltData[(i * profWidth) + j * divX];
                                        if (profDatacp[(i * (profWidth / divX)) + j] > maxp)
                                            maxp = profDatacp[(i * (profWidth / divX)) + j];
                                        if (intensDatacp[(i * (profWidth / divX)) + j] > maxi)
                                            maxi = intensDatacp[(i * (profWidth / divX)) + j];
                                        if (lltDatacp[(i * (profWidth / divX)) + j] > maxl)
                                            maxl = lltDatacp[(i * (profWidth / divX)) + j];
                                    
                                    }

                                //-------------------------------------------------
                                // Scaling applied for ease of visual understanding
                                //-------------------------------------------------
                                maxp = (maxp==0) ? 1 : maxp;
                                maxi = (maxi==0) ? 1 : maxi;
                                maxl = (maxl==0) ? 1 : maxl;
                                divp = 32767 / maxp;
                                divi = 32767 / maxi;
                                divl = 32767 / maxl;
                             for (int i = 0; i < profHeight; i++)
                                for (int j = 0; j < profWidth / divX; j++)
                                {

                                    profDatacp[(i * (profWidth / divX)) + j] = (short)(profDatacp[(i * (profWidth / divX)) + j] * divp);
                                    intensDatacp[(i * (profWidth / divX)) + j] = (short)(intensDatacp[(i * (profWidth / divX)) + j] * divi);
                                    lltDatacp[(i * (profWidth / divX)) + j] = (short)(lltData[(i * profWidth) + j * divX]  * divl);

                                }
                             //-------------------------------------------------
                             //-------------------------------------------------


                                Action action;

                                action = delegate
                                {
                                    border1.Height = profHeight;
                                    border1.Width = profWidth / divX;
                                    if (border1.Height > MaxDispY)
                                        border1.Height = MaxDispY;
                                    if (border1.Width > MaxDispX)
                                        border1.Width = MaxDispX;
                                };
                                border1.Dispatcher.Invoke(action);
                                
                                profSrc = BitmapSource.Create((profWidth / divX), profHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, profDatacp, ((2 * profWidth) / divX));
                                intenSrc = BitmapSource.Create((profWidth / divX), profHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, intensDatacp, ((2*profWidth) / divX));
                                lltSrc = BitmapSource.Create((profWidth / divX), profHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, lltDatacp, ((2*profWidth) / divX));

                                //profSrc = BitmapSource.Create(profWidth, profHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, profData, profWidth * 2);
                                //intenSrc = BitmapSource.Create(profWidth, profHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, intensData, profWidth * 2);
                                //lltSrc = BitmapSource.Create(profWidth, profHeight, dpi, dpi, System.Windows.Media.PixelFormats.Gray16, null, lltData, profWidth * 2);

                                profSrc.Freeze();
                                intenSrc.Freeze();
                                lltSrc.Freeze();
                                Action actionp = delegate { profDispImg.Source = profSrc; };
                                Action actioni = delegate { intenDispImg.Source = intenSrc; };
                                Action actionl = delegate { lltDispImg.Source = lltSrc; };
                                profDispImg.Dispatcher.Invoke(actionp);
                                intenDispImg.Dispatcher.Invoke(actioni);
                                lltDispImg.Dispatcher.Invoke(actionl);

                                action = delegate { liveDispImg.Source = null; };
                                liveDispImg.Dispatcher.Invoke(action);
                                
                   }
                    profValid = 0;  
                }
            }
        }
        private void Init_Focus(object sender, RoutedEventArgs e)
        {
            canvas1.Visibility = System.Windows.Visibility.Visible;
            grid5.Visibility = System.Windows.Visibility.Hidden;
            grid6.Visibility = System.Windows.Visibility.Hidden;
            grid4.Visibility = System.Windows.Visibility.Visible;
            image1.Visibility = System.Windows.Visibility.Visible;

            hide_images();
            
        }
        public static int inpWidth, inpHeight, inpStartX, inpStartY;
        public static int gainEnable = 0;
        public static int gain = 0;
        private void sensorInfo_Focus(object sender, RoutedEventArgs e)
        {

            canvas1.Visibility = System.Windows.Visibility.Hidden;
            grid6.Visibility = System.Windows.Visibility.Hidden;
            image1.Visibility = System.Windows.Visibility.Visible;
            hide_images();
            int ret = 100;
            string str = "";
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                //--------------------------------------
                // Read Sensor IP Address
                //--------------------------------------
                ret = SRAPI.getIp(SensorId, ref str);
                Console.WriteLine("IP - {0}", str);
                if (ret != 0) textBox10.Text = "Error!";
                else textBox10.Text = str;

                //--------------------------------------
                // Read MAC ID
                //--------------------------------------
                string macstr = "";
                ret = SRAPI.getMACAdr(SensorId, ref macstr);
                Console.WriteLine(macstr, " MAC ID");
                if (ret != 0) textBox9.Text = "Error!";
                else textBox9.Text = macstr;

                //--------------------------------------
                // Read Serial Number
                //--------------------------------------
                string serial = "";
                ret = SRAPI.getSerial(SensorId, ref serial);
                Console.WriteLine(serial, " Serial No.");
                if (ret != 0) textBox8.Text = "Error!";
                else textBox8.Text = serial;


                //--------------------------------------
                // Read Software Version
                //--------------------------------------
                ret = SRAPI.getSwVersion(SensorId, ref str);
                Console.WriteLine(str, "Sw version");
                if (ret != 0) textBox11.Text = "Error!";
                else textBox11.Text = str;
                //--------------------------------------
                // Read Hardware Version
                //--------------------------------------
                ret = SRAPI.getHwVersion(SensorId, ref str);
                Console.WriteLine(str, "Hw version");
                if (ret != 0) textBox12.Text = "Error!";
                else textBox12.Text = str;
                
                //--------------------------------------
                // Read Sensor Type
                //--------------------------------------
                ret = SRAPI.getSensorType(SensorId, ref str);
                Console.WriteLine(str, "Part Number");
                if (ret != 0) textBox6.Text = "Error!";
                else textBox6.Text = str;


            }

            else
            {

                textBox6.Text = "N.A";
                textBox8.Text = "N.A";
                textBox9.Text = "N.A";
                textBox10.Text = "N.A";
                textBox11.Text = "N.A";
                textBox12.Text = "N.A";
            }

            

        }
        private void show_live_buttonClick(object sender, RoutedEventArgs e)
        {
            liveDispImg.Visibility = System.Windows.Visibility.Visible;
            profDispImg.Visibility = System.Windows.Visibility.Hidden;
            intenDispImg.Visibility = System.Windows.Visibility.Hidden;
            lltDispImg.Visibility = System.Windows.Visibility.Hidden;
            border1.Visibility = System.Windows.Visibility.Visible;

            button13.IsEnabled = false;
            button10.IsEnabled = true;
            button14.IsEnabled = true;
            button15.IsEnabled = true;

        }
        private void show_profile_buttonClick(object sender, RoutedEventArgs e)
        {

            liveDispImg.Visibility = System.Windows.Visibility.Hidden;
            profDispImg.Visibility = System.Windows.Visibility.Visible;
            intenDispImg.Visibility = System.Windows.Visibility.Hidden;
            lltDispImg.Visibility = System.Windows.Visibility.Hidden;
            border1.Visibility = System.Windows.Visibility.Visible;

            button13.IsEnabled = true;
            button10.IsEnabled = false;
            button14.IsEnabled = true;
            button15.IsEnabled = true;
        }
        private void show_intens_buttonClick(object sender, RoutedEventArgs e)
        {

            liveDispImg.Visibility = System.Windows.Visibility.Hidden;
            profDispImg.Visibility = System.Windows.Visibility.Hidden;
            intenDispImg.Visibility = System.Windows.Visibility.Visible;
            lltDispImg.Visibility = System.Windows.Visibility.Hidden;
            border1.Visibility = System.Windows.Visibility.Visible;

            button13.IsEnabled = true;
            button10.IsEnabled = true;
            button14.IsEnabled = false;
            button15.IsEnabled = true;

        }
        private void show_llt_buttonClick(object sender, RoutedEventArgs e)
        {

            liveDispImg.Visibility = System.Windows.Visibility.Hidden;
            profDispImg.Visibility = System.Windows.Visibility.Hidden;
            intenDispImg.Visibility = System.Windows.Visibility.Hidden;
            lltDispImg.Visibility = System.Windows.Visibility.Visible;
            border1.Visibility = System.Windows.Visibility.Visible;

            button13.IsEnabled = true;
            button10.IsEnabled = true;
            button14.IsEnabled = true;
            button15.IsEnabled = false;

        }
        public void hide_images()
        {

            liveDispImg.Visibility = System.Windows.Visibility.Hidden;
            profDispImg.Visibility = System.Windows.Visibility.Hidden;
            intenDispImg.Visibility = System.Windows.Visibility.Hidden;
            lltDispImg.Visibility = System.Windows.Visibility.Hidden;

            border1.Visibility = System.Windows.Visibility.Hidden;
        }
        private void output_Check(object sender, RoutedEventArgs e)
        {
            int ret;
            if (output0.IsChecked == true) 
                ret = SRAPI.setOutput(SensorId, 0, 1);
            else if (output0.IsChecked == false) 
                ret = SRAPI.setOutput(SensorId, 0, 0);

            if (output1.IsChecked == true)
                ret = SRAPI.setOutput(SensorId, 1, 1);
            else if (output1.IsChecked == false)
                ret = SRAPI.setOutput(SensorId, 1, 0);        
        }
        private void previewTextInput(object sender, TextCompositionEventArgs e)
        {
            e.Handled = !areAllValidNumericChars(e.Text);
            base.OnPreviewTextInput(e); 
        }
        bool areAllValidNumericChars(string str)
        {
            bool ret = true;
            int l = str.Length;
            for (int i = 0; i < l; i++)
            {
                char ch = str[i];
                ret &= Char.IsDigit(ch);
            }
         
            return ret;
        }
        int actsenswidth, actsensheight;
        public static bool roiSet = false;
        public static bool expSet = false;
        private void setROI_Clicked(object sender, RoutedEventArgs e)
        {

            if (param_loaded == false)
                return;

            if (textBox1.Text == "")
                textBox1.Text = "0";
            if (textBox2.Text == "")
                textBox2.Text = "0";
            if (textBox3.Text == "")
                textBox3.Text = "0";
            if (textBox4.Text == "")
                textBox4.Text = "0";
            inpWidth = int.Parse(textBox1.Text);
            inpHeight = int.Parse(textBox2.Text);
            inpStartX = int.Parse(textBox3.Text);
            inpStartY = int.Parse(textBox4.Text);

            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
           
            int ret;
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                ret = SRAPI.getSensorSize(SensorId, ref actsenswidth, ref actsensheight);

                if (inpWidth < 0 || inpWidth > actsenswidth)
                {
                    inpWidth = actsenswidth;
                    textBox1.Text = inpWidth.ToString();
                }

                if (inpHeight < 0 || inpHeight > actsensheight)
                {
                    inpHeight = actsensheight;
                    textBox2.Text = inpHeight.ToString();
                }

                if (inpStartX < 0 || inpStartX >= actsenswidth)
                {
                    inpStartX = 0;
                    textBox3.Text = inpStartX.ToString();
                }

                if (inpStartY < 0 || inpStartY >= actsensheight)
                {
                    inpStartY = 0;
                    textBox4.Text = inpStartY.ToString();
                }


                if (inpWidth % 8 != 0)
                {
                    inpWidth = inpWidth - (inpWidth % 8);
                    textBox1.Text = inpWidth.ToString();
                }

                if (inpStartX % 8 != 0)
                {
                    inpStartX = inpStartX - (inpStartX % 8);
                    textBox3.Text = inpStartX.ToString();
                }


                ret = SRAPI.setImager(SensorId, inpStartX, inpStartY, inpWidth, inpHeight, gainEnable, gain);
                roiSet = true;

            }

            else
            {
                if (inpWidth < 0 || inpWidth > 1280)
                {
                    inpWidth = 1280;
                    textBox1.Text = inpWidth.ToString();
                }

                if (inpHeight < 0 || inpHeight > 1024)
                {
                    inpHeight = 1024;
                    textBox2.Text = inpHeight.ToString();
                }

                if (inpStartX <0 || inpStartX >= 1280)
                {
                    inpStartX = 0;
                    textBox3.Text = inpStartX.ToString();
                }

                if (inpStartY <0  || inpStartY >= 1024)
                {
                    inpStartY = 0;
                    textBox4.Text = inpStartY.ToString();
                }

            }

        }
        public static int expSmall, expLarge, enDoubleExpo;
        private void set_Exposure_Click(object sender, RoutedEventArgs e)
        {
            if (param_loaded == false)
                return;

            if (textBox5.Text == "")
                textBox5.Text = "0";
            if (textBox7.Text == "")
                textBox7.Text = "0";

            expSmall = int.Parse(textBox5.Text);
            expLarge = int.Parse(textBox7.Text);
            if (checkBox2.IsChecked == true)
            {
                enDoubleExpo = 1;
            }
            else
            {
                enDoubleExpo = 0;
            }


            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
           
            int ret;
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                if (expSmall < 0)
                {
                    expSmall = 0;
                    textBox5.Text = expSmall.ToString();
                }
                if (expLarge < 0)
                {
                    expLarge = 0;
                    textBox7.Text = expLarge.ToString();
                }
                ret = SRAPI.setExposure(SensorId, enDoubleExpo, expSmall, expLarge);
                expSet = true;
            }
        }
        public static bool param_loaded;
        private void captureImage_Click(object sender, MouseButtonEventArgs e)
        {


            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState != SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                Debug.WriteLine("\rThe Sensor is not connected");
            }
            else
            {
                
                
                int ret;

                    //--------------------------------------
                    // Stop the Sensor
                    //--------------------------------------
                    ret = SRAPI.stopSensor(SensorId);
                    if (ret != 0)
                        Debug.WriteLine("\rStop Sensor Failed" + ret);
                    else
                    {
                        Debug.WriteLine("\rSensor Stopped");
                        Debug.WriteLine("\rSee the console window for results");
                    }




                    button17.Visibility = System.Windows.Visibility.Hidden;
                    button11.Visibility = System.Windows.Visibility.Visible;


                    config_Param_Func(0); // par = 0 for live image; 1 for profile


                    if (param_loaded == true)
                    {
                        button18.IsEnabled = true;
                        button1.IsEnabled = true;

                        if (!expSet)
                        {
                            //--------------------------------------
                            // Get Exposure time
                            //--------------------------------------
                            ret = SRAPI.getExposure(SensorId, ref enDoubleExpo, ref expSmall, ref expLarge);
                            if (ret == 0)
                            {
                                if (enDoubleExpo == 1)
                                    checkBox2.IsChecked = true;
                                else
                                    checkBox2.IsChecked = false;

                                textBox5.Text = expSmall.ToString();
                                textBox7.Text = expLarge.ToString();
                                if (checkBox2.IsChecked == false)
                                    textBox7.IsEnabled = false;
                                else
                                    textBox7.IsEnabled = true;
                            }
                        }
                        else
                        {
                            //--------------------------------------
                            // Set Exposure time
                            //--------------------------------------
                            ret = SRAPI.setExposure(SensorId, enDoubleExpo, expSmall, expLarge);
                          }
                    }
                    //--------------------------------------
                    // Clear LiveImage Buffer
                    //--------------------------------------
                    liveDispImg.Source = null;
                    //--------------------------------------
                    // Start the Sensor
                    //--------------------------------------
                    ret = SRAPI.startSensor(SensorId);
                    if (ret != 0)
                        Debug.WriteLine("\rSensor Start Failed" + ret);
                    else
                    {
                        Debug.WriteLine("\rSensor Started");
                        Debug.WriteLine("\rSee the console window for results");
                    }

                    button2.Visibility = System.Windows.Visibility.Hidden;
                    button19.Visibility = System.Windows.Visibility.Visible;

                    liveDispImg.Visibility = System.Windows.Visibility.Visible;
                    profDispImg.Visibility = System.Windows.Visibility.Hidden;
                    intenDispImg.Visibility = System.Windows.Visibility.Hidden;
                    lltDispImg.Visibility = System.Windows.Visibility.Hidden;
                    border1.Visibility = System.Windows.Visibility.Visible;

                    button13.IsEnabled = false;
                    button10.IsEnabled = true;
                    button14.IsEnabled = true;
                    button15.IsEnabled = true;

            }
        }
        public static int divX = 1;
        public static int divY = 1;
        public static int MaxDispX = 376; // Maximum possible X display resolution
        public static int MaxDispY = 240;  // Maximum possible Y display resolution
        private void setup_Click(object sender, MouseButtonEventArgs e)
        {
            canvas1.Visibility = System.Windows.Visibility.Visible;
            grid4.Visibility = System.Windows.Visibility.Hidden;
            grid5.Visibility = System.Windows.Visibility.Visible;
            grid6.Visibility = System.Windows.Visibility.Visible;
            border1.Visibility = System.Windows.Visibility.Visible;
            image1.Visibility = System.Windows.Visibility.Hidden;

            button13.IsEnabled = false;
            button10.IsEnabled = false;
            button14.IsEnabled = false;
            button15.IsEnabled = false;

            liveDispImg.Visibility = System.Windows.Visibility.Hidden;
            profDispImg.Visibility = System.Windows.Visibility.Hidden;
            intenDispImg.Visibility = System.Windows.Visibility.Hidden;
            lltDispImg.Visibility = System.Windows.Visibility.Hidden;

            if (checkBox2.IsChecked == true)
                textBox7.IsEnabled = true;
            else
                textBox7.IsEnabled = false;
            

            if (param_loaded == false)
            {
                button18.IsEnabled = false;
                button1.IsEnabled = false;
            }
            button12.Visibility = System.Windows.Visibility.Visible;
            button22.Visibility = System.Windows.Visibility.Hidden;


            button11.Visibility = System.Windows.Visibility.Visible;
            button17.Visibility = System.Windows.Visibility.Hidden;

            button2.Visibility = System.Windows.Visibility.Visible;
            button19.Visibility = System.Windows.Visibility.Hidden;
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------

            border1.Height = MaxDispY;
            border1.Width = MaxDispX;

            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                int ret;
                int temp;

                ret = SRAPI.getSensorSize(SensorId, ref inpWidth, ref inpHeight);
                if (ret == 0)
                {
                    textBox1.Text = inpWidth.ToString();
                    textBox2.Text = inpHeight.ToString();
                    textBox3.Text = ((int)0).ToString();
                    textBox4.Text = ((int)0).ToString();

                    divX = 1;
                    divY = 1;
                
                   temp = inpWidth;
                   while (temp > MaxDispX)
                   {
                       temp /= 2;
                       divX *= 2;
                   }

                   temp = inpHeight;
                   while (temp > MaxDispY)
                   {
                       temp /= 2;
                       divY *= 2;
                   }


                }
                else
                {
                    textBox1.Text = ((int)1280).ToString();
                    textBox2.Text = ((int)1024).ToString();
                    textBox3.Text = ((int)0).ToString();
                    textBox4.Text = ((int)0).ToString();

                }


                ret = SRAPI.getExposure(SensorId, ref enDoubleExpo, ref expSmall, ref expLarge);
                if (ret == 0)
                {
                    if (enDoubleExpo == 1)
                        checkBox2.IsChecked = true;
                    else
                        checkBox2.IsChecked = false;

                    textBox5.Text = expSmall.ToString();
                    textBox7.Text = expLarge.ToString();
                    if (checkBox2.IsChecked == false)
                        textBox7.IsEnabled = false;
                    else
                        textBox7.IsEnabled = true;
                }



            }
        }
        public static bool laseron = false;
        private void laser_On_Click(object sender, RoutedEventArgs e)
        {
            int ret = 0;
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                //--------------------------------------
                // Set The Laser Properties
                //--------------------------------------
                ret = SRAPI.setLaser(SensorId, SRAPI.Constants.LASER_CONTINOUS, SRAPI.Constants.LASER_DONOTCHANGE, SRAPI.Constants.LASER_ENABLE, 100);
                if (ret == 0)
                {
                    button12.Visibility = System.Windows.Visibility.Hidden;
                    button22.Visibility = System.Windows.Visibility.Visible;

                }


            }
        }
        private void laser_Off_Click(object sender, RoutedEventArgs e)
        {
            int ret = 0;
            //--------------------------------------
            // check if sensor is connected
            //--------------------------------------
            int conState = SRAPI.getConnectionState(SensorId);
            if (conState == SRAPI.Constants.STATE_CAMERA_CONNECTED)
            {
                //--------------------------------------
                // Set The Laser Properties
                //--------------------------------------
                ret = SRAPI.setLaser(SensorId, SRAPI.Constants.LASER_CONTINOUS, SRAPI.Constants.LASER_DONOTCHANGE, SRAPI.Constants.LASER_DISABLE, 100);
                if (ret == 0)
                {
                    button12.Visibility = System.Windows.Visibility.Visible;
                    button22.Visibility = System.Windows.Visibility.Hidden;

                }


            }
            

        }

        private void doubleExposureEnabled(object sender, RoutedEventArgs e)
        {
            if (true == checkBox2.IsChecked)
                textBox7.IsEnabled = true;
            else
                textBox7.IsEnabled = false;
        }

   }
}

 